rem ricompila_invalidi.sql 1.1.0 marted 27 agosto 2002
rem Copyright (c) 1999-2002 Matteo Vitturi.  All Rights Reserved.
rem 
rem NAME
rem   ricompila_invalidi.sql
rem
rem

set serveroutput on


--spool ricompila_invalidi_slave.sql

declare

  type record_of_object is record ( 
       livello number,
       utente varchar2(30), 
       tipo   varchar2(30), 
       nome   varchar2(30)
       );

  type table_of_object is
       table of record_of_object
       index by binary_integer;

    v_lista table_of_object;

  type record_of_dependencies is record ( 
       utente varchar2(30), 
       tipo   varchar2(30), 
       nome   varchar2(30),
       dip_utente varchar2(30), 
       dip_tipo   varchar2(30), 
       dip_nome   varchar2(30)
       );

  type table_of_dependencies is
       table of record_of_dependencies
       index by binary_integer;

    v_dipendenze table_of_dependencies;


    function esiste_in_lista( 
        p_livello in number,
        p_utente in varchar2, 
        p_tipo in varchar2, 
        p_nome in varchar2) return boolean
    is
      v_trovato boolean := false;
      v_quanti number := v_lista.count;
    begin
      for i in 1..v_quanti
      loop 
          if v_lista(i).utente = p_utente and
             v_lista(i).tipo = p_tipo and
             v_lista(i).nome = p_nome 
             then
             return true;    
          end if;
      end loop;
      return false;
    end;

    procedure inserisci_in_lista( 
        p_livello in number,
        p_utente in varchar2, 
        p_tipo in varchar2, 
        p_nome in varchar2)
    is
      v_trovato boolean := false;
      v_quanti number := v_lista.count;
    begin
      for i in 1..v_quanti
      loop 
          if v_lista(i).utente = p_utente and
             v_lista(i).tipo like 'PACKAGE%' and p_tipo = 'PACKAGE' and
             v_lista(i).nome = p_nome 
             then
             v_lista(i).tipo := p_tipo;
             v_trovato := true;    
             exit;
          end if;
          if v_lista(i).utente = p_utente and
             v_lista(i).tipo = p_tipo and
             v_lista(i).nome = p_nome 
             then
             v_trovato := true;    
             exit;
          end if;
      end loop;
      if v_trovato = false then
         v_lista(v_quanti+1).livello := p_livello;
         v_lista(v_quanti+1).utente := p_utente;
         v_lista(v_quanti+1).tipo := p_tipo;
         v_lista(v_quanti+1).nome := p_nome;
      end if;
    end;

    procedure trova_dipendenza( 
        p_indice in out number,
        p_utente in varchar2, 
        p_tipo in varchar2, 
        p_nome in varchar2,
        p_dip_utente in out varchar2, 
        p_dip_tipo in out varchar2, 
        p_dip_nome in out varchar2) 
    is
      v_trovato boolean := false;
      v_quanti number := v_dipendenze.count;
    begin
      for i in p_indice .. v_quanti
      loop 
          if v_dipendenze(i).utente = p_utente and
             v_dipendenze(i).tipo = p_tipo and
             v_dipendenze(i).nome = p_nome 
             then
               p_indice := i;
               p_dip_utente := v_dipendenze(i).dip_utente;
               p_dip_tipo := v_dipendenze(i).dip_tipo;
               p_dip_nome := v_dipendenze(i).dip_nome;
             --return true;    
          end if;
      end loop;
      p_dip_utente := null;
      p_dip_tipo := null;
      p_dip_nome := null;
      --return false;
    end;

    procedure compila_oggetto( 
        p_livello in number,
        p_utente in varchar2, 
        p_tipo in varchar2, 
        p_nome in varchar2,
        p_indice in number )
    is
        v_status all_objects.status%type;  
        v_referenced_owner varchar2(30); 
        v_referenced_type varchar2(30);
        v_referenced_name varchar2(30);
        v_indice number := p_indice;
    begin
        if P_livello > 10 then 
          return;
        end if;
        --
        if esiste_in_lista( p_livello, p_utente, p_tipo, p_nome ) then
          return;
        end if;
        loop
          trova_dipendenza( v_indice, p_utente, p_tipo, p_nome,
                            v_referenced_owner, v_referenced_type, v_referenced_name );
          exit when v_referenced_name is null;
            -- percorri nuovamente l'albero,
          compila_oggetto( p_livello + 1, 
                            v_referenced_owner, 
                            v_referenced_type, 
                            v_referenced_name, 1 );  
        end loop;
        -- ora compilalo se invalido.
        --dbms_output.put_line( livello || ': '|| tipo || ' ' || utente ||'.'|| nome );
        inserisci_in_lista( p_livello + 1, p_utente, p_tipo, p_nome );
    end;
  
    procedure crea_script
    is
    begin

        dbms_output.put_line( ' ');
        dbms_output.put_line( 'REM Ci sono ' || v_lista.count || ' oggetti invalidi.' ||
                              ' da ricompilare nell''ordine seguente...');

        for i in 1..v_lista.count
        loop 
            if    v_lista(i).tipo = 'FUNCTION' then
              dbms_output.put_line('ALTER FUNCTION ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE;');
            elsif v_lista(i).tipo = 'PROCEDURE' then
              dbms_output.put_line('ALTER PROCEDURE ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE;');
            elsif v_lista(i).tipo = 'PACKAGE BODY' then
              dbms_output.put_line('ALTER PACKAGE ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE BODY;');
            elsif v_lista(i).tipo = 'PACKAGE' then
              dbms_output.put_line('ALTER PACKAGE ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE PACKAGE;');
            elsif v_lista(i).tipo = 'VIEW' then
              dbms_output.put_line('ALTER VIEW ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE;');
            elsif v_lista(i).tipo = 'TRIGGER' then
              dbms_output.put_line('ALTER TRIGGER ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE;');
            else dbms_output.put_line('REM !! ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' !!');
            end if;
        end loop;
    end;
  
    procedure esegui_script
    is
      v_attenzione boolean := FALSE;
    begin

        dbms_output.put_line( ' ');
        dbms_output.put_line( 'Eseguendo la ricompilazione risulta...');

        for i in 1..v_lista.count
        loop 
          begin
            if    v_lista(i).tipo = 'FUNCTION' then
              execute immediate 'ALTER FUNCTION ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE' ;
            elsif v_lista(i).tipo = 'PROCEDURE' then
              execute immediate 'ALTER PROCEDURE ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE' ;
            elsif v_lista(i).tipo = 'PACKAGE BODY' then
              execute immediate 'ALTER PACKAGE ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE BODY' ;
            elsif v_lista(i).tipo = 'PACKAGE' then
              execute immediate 'ALTER PACKAGE ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE PACKAGE' ;
            elsif v_lista(i).tipo = 'VIEW' then
              execute immediate 'ALTER VIEW ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE' ;
            elsif v_lista(i).tipo = 'TRIGGER' then
              execute immediate 'ALTER TRIGGER ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' COMPILE' ;
            else dbms_output.put_line('REM !! ' || v_lista(i).utente || '.' 
              || v_lista(i).nome || ' !!');
            end if;
          exception
            when others then 
              dbms_output.put_line(v_lista(i).tipo || ' ' || 
                v_lista(i).utente || '.' || v_lista(i).nome );
              dbms_output.put_line(sqlerrm);
              v_attenzione := TRUE;
          end;
        end loop;
        if v_attenzione = FALSE then 
          dbms_output.put_line( '... tutto OK.');
        else
          dbms_output.put_line( '... che qualcosa e'' andato storto.');
        end if;
    end;
  
    procedure popola_dipendenze( 
        p_utente in varchar2, 
        p_tipo in varchar2, 
        p_nome in varchar2,
        p_dip_utente in varchar2, 
        p_dip_tipo in varchar2, 
        p_dip_nome in varchar2)
    is
      v_quanti number := v_dipendenze.count;
    begin
        v_dipendenze(v_quanti+1).utente := p_utente;
        v_dipendenze(v_quanti+1).tipo := p_tipo;
        v_dipendenze(v_quanti+1).nome := p_nome;
        v_dipendenze(v_quanti+1).dip_utente := p_dip_utente;
        v_dipendenze(v_quanti+1).dip_tipo := p_dip_tipo;
        v_dipendenze(v_quanti+1).dip_nome := p_dip_nome;
    end;

    procedure crea_log
    is
    begin
        dbms_output.put_line( ' ');
        dbms_output.put_line( 'REM Ci sono ' || v_dipendenze.count || ' dipendenze ' ||
                   ' che coinvolgono oggetti invalidi.');
        for i in 1..v_dipendenze.count
        loop 
            dbms_output.put_line( 'REM ' ||
                                  v_dipendenze(i).tipo || ' ' || 
                                  v_dipendenze(i).utente ||'.'|| 
                                  v_dipendenze(i).nome || '  ->  ' ||
                                  v_dipendenze(i).dip_tipo || ' ' || 
                                  v_dipendenze(i).dip_utente ||'.'|| 
                                  v_dipendenze(i).dip_nome );
        end loop;
        dbms_output.put_line( ' ' );
        for i in 1..v_lista.count
        loop 
            dbms_output.put_line( 'REM (' || 
                                  v_lista(i).livello || ') ' || 
                                  lpad(' ',v_lista(i).livello+v_lista(i).livello) ||
                                  v_lista(i).tipo || ' ' || 
                                  v_lista(i).utente ||'.'|| 
                                  v_lista(i).nome );
        end loop;
    end;

    procedure compila_invalidi 
    is
    begin
        for x in (
            select O.owner,            O.object_type,     O.object_name,     
                   D.referenced_owner, D.referenced_type, D.referenced_name,
                   O2.status
              from all_dependencies D
                 , all_objects O
                 , all_objects O2
             where O.status = 'INVALID'
               and D.owner (+) = O.owner
               and D.type  (+) = O.object_type
               and D.name  (+) = O.object_name  
               and D.referenced_owner = O2.owner (+)
               and D.referenced_type = O2.object_type (+)
               and D.referenced_name = O2.object_name (+) 
               and O.owner = USER
             order by O.timestamp
        )
        loop
           --if nvl(x.status,'INVALID') = 'INVALID' then
             popola_dipendenze( x.owner,            x.object_type,     x.object_name,
                                x.referenced_owner, x.referenced_type, x.referenced_name);  
           --end if;
        end loop;

        for i in 1..v_dipendenze.count
        loop 
           compila_oggetto( 1, v_dipendenze(i).utente, 
                               v_dipendenze(i).tipo, 
                               v_dipendenze(i).nome,
                               i );  
        end loop;
        crea_script;
        esegui_script;
        --crea_log;

    end ;   

begin
  dbms_output.enable(1000000);
  compila_invalidi;
end;
/

--spool off

--prompt All done!
--prompt 
--prompt Il file ricompila_invalidi_slave.sql contiene la sequenza corretta di ricompilazione.
